<template>
  <v-card light>
    <v-card-title>Add Todo</v-card-title>
    <hr class="mx-3" />
    <v-card-text>
        <v-form
            ref="form"
            lazy-validation>
            <v-text-field 
                label="Title" 
                v-model="formData.title"
                required
                :rules="[v => !!v || 'Title is required']"></v-text-field>
            <v-text-field 
                label="Description" 
                v-model="formData.description"></v-text-field>
            <v-select 
                label="Status" 
                v-model="status"
                :items="items"
                item-text="text"
                item-value="value"
                required
                :rules="[v => !!v || 'Status is required']">
            </v-select>
        </v-form>
        <v-alert 
            :value="alert" 
            text
            type="error">Failed to add todo : {{econtent}}</v-alert>
    </v-card-text>
    <v-card-actions class="justify-end">
        <v-btn class="btn-primary mx-1" 
            @click="addTodo" 
            :loading="loading">Save</v-btn>
        <v-btn class="btn-secondary mx-1" 
            :loading="loading"
            @click="closeThis">Close</v-btn>
    </v-card-actions>
  </v-card>
</template>

<script>
export default {
    data(){
        return{
            formData : {
                title : "",
                description : "",
                isActive: ""
            },
            status: "",
            econtent: "",
            alert: false,
            loading: false,
            items: [{text: 'Active', value: 'true'}, {text: 'Inactive', value: 'false'}],
        }
    },
    watch: {
        status(newVal){
            //convert select dropdown to true or false
            this.formData.isActive = (newVal === 'true');
        }
    },
    methods:{
        closeThis(){
            this.$emit('closeDialog');
        },
        addTodo(){
            if (this.$refs.form.validate()){
                this.loading = true;
                this.$axios.post('/todo/', this.formData)
                    .then((resp) => {
                        if (resp.statusCode && resp.statusCode == 400){
                            this.econtent = resp.message;
                        }
                        else{
                            this.$emit('showAlert', {type: "success", text: "Added Success"});
                            this.$emit('closeDialog');
                            this.$emit('reloadList');
                        }
                        this.loading = false;
                    })
                    .catch((err) =>{
                        alert(err);
                        console.log(err);
                        this.loading = false;
                    });
            }
        }
    }
}
</script>

<style>

</style>